/*
JD 374322
PV259 Programovani generativniho designu
Projekt No. 1 - square pattern generator
*/

// setup
void setup() {
  size (804, 600);
  frameRate(2); 
}

// promenne
int pxSize = 12;                 // rozliseni pixelu
int symbolSize = 5;              // velikost symbolu v pixelech (sude cislo)
int size = symbolSize*pxSize;    // celikova velikost symbolu
int halfAxis = (symbolSize-1)/2; // oprava pro symetrii podle osy Y 
int sizeX = size;                // odstup symbolu v X
int sizeY = size;                // odstup symbolu v Y                 
int axSize = halfAxis*pxSize;    // velikost symbolu pred zrcadlenim s opravou symetrie
int coloredMode = 1;             // colored mod
int n;                           // random seed pro pixel
//float symbolColor;
 
// main 
void draw() {
  background(225);                              // pozadi
  for (int y = 0; y<height; y+=sizeY) {         // pozice symbolu v Y
    for (int x = 0; x<width; x+=sizeX) {        // pozice symbolu v X
      pushMatrix();                             // zmena souradnic
      translate(x, y);                          // posun symbolu
      for (int xx=axSize; xx>=0; xx-=pxSize) {  // generovani symbolu v X
        for (int yy = 0; yy<size; yy+=pxSize) { // generovani symbolu v Y
          // generovani
          n = int(random(10));                  // generovani random pro kazdy pixel, urcuje zda tam pixel je, ci neni
          if ( (n%2) == 0) {                    // jen kazde sude cislo
            if (coloredMode == 1) {
              //symbolColor= random(0,255);
//              fill(symbolColor, symbolColor, symbolColor);
              fill(random(0,255), random(0,255), random(0,255));  // barva pixelu v colored modu    
            } else {
              fill(255);                        // barva pixelu standard
            }
            stroke(120);
            rect(xx, yy, pxSize, pxSize);       // generovani symbolu
            if (xx!=halfAxis*pxSize) rect(2*halfAxis*pxSize-xx, yy, pxSize, pxSize); // zrcadleni dle osy Y symbolu
          }
        }
      }
      popMatrix();                              // navrat souradnic
    }
  }
}
 
// ovladani 
int play = 1;
void keyPressed() {
  if ((key == ' ' ) && (play==1)) {
    noLoop();
    play--;
  }
  else {
    loop();
    play++;
  }
  if (key == 'm' || key == 'M'){
    pxSize++;
    size = symbolSize*pxSize;
    axSize = halfAxis*pxSize;
  }
  if ((key == 'n'  || key == 'N') && (sizeY > symbolSize)) {
    pxSize--;
    size = symbolSize*pxSize;
    axSize = halfAxis*pxSize;
  }
  if (keyCode == RIGHT) {
    sizeX += symbolSize;
  }
  if ((keyCode == LEFT) && (sizeX > symbolSize)) {
    sizeX -= symbolSize;
  }
  if (keyCode == UP) {
    sizeY += symbolSize;
  }
  if ((keyCode == DOWN) && (pxSize > 1)) {
    sizeY -= symbolSize;
  }
  if (key == 'c'  || key == 'C') {
    if (coloredMode == 1) {
      coloredMode--;
    } else {
      coloredMode++;
    }
  }  
}
